SystemOrganization addCategory: #'GT-GlamourDebugger'!

!Object methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ false! !

!GLMBrowser methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ true! !

GTDebugger subclass: #GTGlamourDebugger
	instanceVariableNames: 'glamourBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugger class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/20/2013 12:28'!
defaultTitle
	^ 'Glamour Debugger'! !

!GTGlamourDebugger class methodsFor: 'testing' stamp: 'AndreiChis 6/19/2013 17:37'!
handlesContext: aContext

	^ aContext receiver isGlamourBrowser! !

!GTGlamourDebugger class methodsFor: 'class initialization' stamp: 'AndreiChis 6/19/2013 16:44'!
initialize 

	"Add ourselves to registry. See [Smalltalk tools]" 
	Smalltalk tools registerDebugger: self withRank: 50.! !

!GTGlamourDebugger class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/19/2013 17:56'!
locateBrowserFor: aContext

	^ (aContext findContextSuchThat:  [ :ctx | ctx receiver isGlamourBrowser ]) receiver! !

!GTGlamourDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/20/2013 12:25'!
browserStructureFor: aGlmBrowser in: aComposite
	
	aComposite roassal 
		title: 'Browser structure';
		painting: [:view :b | 
			aGlmBrowser viewTreeOn: view ]! !

!GTGlamourDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/20/2013 12:26'!
browserTransmissionsIn: browser
	
	browser transmit
		from: #stack port: #context;
		to: #browser;
		andShow: [ :composite | self browserStructureFor: glamourBrowser in: composite ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/24/2013 20:53'!
debuggerStructureIn: browser

	browser
			row: [ :row | 
						row
							column: [ :c |
								c
									row: #stack;
									row: #code ];
							column: #browser ] span: 4;
			row: #inspector span: 3.! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:25'!
debuggerTransmissionsIn: browser.
		
	super debuggerTransmissionsIn: browser.
	self browserTransmissionsIn: browser.! !

!GTGlamourDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/19/2013 17:54'!
startOn: aSession

	glamourBrowser := self class locateBrowserFor: aSession context.
	super startOn: aSession! !
GTGlamourDebugger initialize!
